#ifndef _Player_h
#define _Player_h

#include <glibmm.h>
#include <gtkmm/socket.h>

class Player
{
public:
	Player();
	virtual ~Player();

	/*
	 *
	 */
	bool is_valid();

	/*
	 *
	 */
	void set_widget(Gtk::Widget *widget);

	/*
	 *
	 */
	Gtk::Widget* get_widget();

	/*
	 *
	 */
	virtual void widget_expose(Gtk::Widget *widget) = 0;

	/*
	 *
	 */
	Glib::Pid get_widget_pid();

	/*
	 *	open movie
	 */
	virtual bool open(const Glib::ustring &uri) = 0;

	/*
	 *
	 */
	virtual bool close() = 0;

	/*
	 *
	 */
	virtual bool is_playing() = 0;

	/*
	 *
	 */
	virtual void play() = 0;

	/*
	 *
	 */
	virtual void pause() = 0;

	/*
	 *	msec
	 *	SubtitleTime(get_duration)
	 */
	virtual long get_duration() = 0;

	/*
	 *	msec
	 *	SubtitleTime(get_position)
	 */
	virtual long get_position() = 0;

	/*
	 *
	 */
	virtual void seek(long position, bool faster=false) = 0;
	/*
	 *
	 */
	virtual void seek(long start, long end, bool faster=false) = 0;

	/*
	 *	signaux sur l'état du lecteur vidéo
	 *	DISABLE: pas de vidéo ou echec
	 *	READY: player disponible pour donner des info (lenght, ...)
	 *	PAUSED: une vidéo est dispo et le lecteur aussi
	 *	PLAYING: joue actuellement une vidéo
	 */
	enum State
	{
		DISABLE,
		READY,
		PAUSED,
		PLAYING
	};

	/*
	 *
	 */
	void set_state(State state);

	/*
	 *
	 */
	State get_state();

	/*
	 *	signaux
	 */
	sigc::signal<void>& get_signal_timeout();

	/*
	 *
	 */
	sigc::signal<void, State>& get_signal_state_changed();


	/*
	 *
	 */
	virtual void show_text(const Glib::ustring &text) = 0;

protected:
	
	bool on_timeout();

protected:
	Gtk::Widget* m_widget_socket;
	Glib::Pid m_widget_pid;
	State m_state;
	sigc::connection m_connection_timeout;
	sigc::signal<void> m_signal_timeout;
	sigc::signal<void, State> m_signal_state_changed;
};

#endif//_Player_h

